diff --git a/Makefile.am b/Makefile.am
index 5542aa1c56..4f773f27e5 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -143,6 +143,7 @@ MODULES =					\
   guix/build-system/minify.scm			\
   guix/build-system/asdf.scm			\
   guix/build-system/copy.scm			\
+  guix/build-system/gerbil.scm                  \
   guix/build-system/glib-or-gtk.scm		\
   guix/build-system/gnu.scm			\
   guix/build-system/guile.scm			\
@@ -190,6 +191,7 @@ MODULES =					\
   guix/build/meson-build-system.scm		\
   guix/build/minify-build-system.scm		\
   guix/build/font-build-system.scm		\
+  guix/build/gerbil-build-system.scm            \
   guix/build/go-build-system.scm		\
   guix/build/android-repo.scm			\
   guix/build/asdf-build-system.scm		\
diff --git a/doc/guix.texi b/doc/guix.texi
index a826171f34..4f2146b7ac 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -7733,6 +7733,27 @@ only one of them.  This is equivalent to passing the @code{-p} argument to
 @code{dune}.
 @end defvr
 
+@defvr {Scheme Variable} gerbil-build-system
+This variable is exported by @code{(guix build-system gerbil)}.  It
+implements a build procedure for Gerbil packages the standard
+@uref{https://cons.io/guide/package-manager.html, Gerbil build
+mechanism}.
+
+It runs the @file{build.ss} Gerbile script, which compiles the package.
+The script can also take custom commands and flags, which can be
+specified by the @code{#:build-flags} parameter.
+
+One can also specify a custom Gerbil package to use for compiling the
+package by specifying the the @code{#:gerbil} parameter.
+
+Gerbil projects don't have a standardized way of running tests, so not
+@code{check} phase is exists by default.
+
+@c TODO: Should Gerbil packages be ‘inputs’ or ‘propagated-inputs’?
+
+As of right now, cross-compilation is not supported.
+@end defvr
+
 @defvr {Scheme Variable} go-build-system
 This variable is exported by @code{(guix build-system go)}.  It
 implements a build procedure for Go packages using the standard
diff --git a/etc/snippets/scheme-mode/guix-package b/etc/snippets/scheme-mode/guix-package
index 9ff6f997d1..e2d645f731 100644
--- a/etc/snippets/scheme-mode/guix-package
+++ b/etc/snippets/scheme-mode/guix-package
@@ -18,6 +18,7 @@
                                           "dune-build-system"
                                           "emacs-build-system"
                                           "font-build-system"
+                                          "gerbil-build-system"
                                           "glib-or-gtk-build-system"
                                           "gnu-build-system"
                                           "go-build-system"
diff --git a/guix/build-system/gerbil.scm b/guix/build-system/gerbil.scm
new file mode 100644
index 0000000000..0dd61767b8
--- /dev/null
+++ b/guix/build-system/gerbil.scm
@@ -0,0 +1,138 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2021 Xinglu Chen <public@yoctocell.xyz>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build-system gerbil)
+  #:use-module (guix utils)
+  #:use-module (guix build-system)
+  #:use-module (guix build-system gnu)
+  #:use-module (guix search-paths)
+  #:use-module (guix packages)
+  #:use-module (guix derivations)
+  #:use-module (ice-9 match)
+  #:export (gerbil-build-system))
+
+;;; Commentary:
+;;;
+;;; Standard build procedure for packages using the Gerbil build system.
+;;;
+;;; Code:
+
+(define %gerbil-build-system-modules
+  ;; Build-side modules imported and used by default.
+  `((guix build gerbil-build-system)
+    (guix build union)
+    ,@%gnu-build-system-modules))
+
+(define (default-gerbil)
+  "Return the default Gerbil package."
+  ;; Lazily resolve the binding to avoid circular dependency.
+  (let ((gerbil (resolve-interface '(gnu packages gerbil))))
+    (module-ref gerbil 'gerbil)))
+
+(define* (lower name
+                #:key source inputs native-inputs outputs system target
+                (gerbil (default-gerbil))
+                #:allow-other-keys
+                #:rest arguments)
+  "Return a bag for NAME."
+  (define private-keywords
+    '(#:source #:target #:gerbil #:inputs #:native-inputs))
+
+  ;; TODO: Cross-compilation support.
+  (and (not target)
+       (bag
+         (name name)
+         (system system)
+         (host-inputs `(,@(if source
+                              `(("source" ,source))
+                              '())
+                        ,@inputs))
+         (build-inputs `(("gerbil" ,gerbil)
+                         ("libc" ,(module-ref (resolve-interface
+                                               '(gnu packages base))
+                                              'glibc))
+                         ("gcc" ,(module-ref (resolve-interface
+                                              '(gnu packages gcc))
+                                             'gcc))
+                         ("binutils" ,(module-ref (resolve-interface
+                                                   '(gnu packages base))
+                                                  'binutils))
+                         ,@native-inputs))
+         (outputs outputs)
+         (build gerbil-build)
+         (arguments (strip-keyword-arguments private-keywords arguments)))))
+
+(define* (gerbil-build store name inputs
+                       #:key
+                       (phases '(@ (guix build gerbil-build-system)
+                                   %standard-phases))
+                       (outputs '("out"))
+                       (search-paths '())
+                       (build-flags ''())
+                       (gerbil (default-gerbil))
+                       ;; Tests are disabled by default because there is no
+                       ;; standard way to test Gerbil packages.  However, some
+                       ;; packages might have custom test phases, so pass the
+                       ;; #:tests? keyword, just in case.
+                       (tests? #f)
+                       (system (%current-system))
+                       (guile #f)
+                       (imported-modules %gerbil-build-system-modules)
+                       (modules '((guix build gerbil-build-system)
+                                  (guix build utils))))
+  (define builder
+    `(begin
+       (use-modules ,@modules)
+       (gerbil-build #:name ,name
+                     #:source ,(match (assoc-ref inputs "source")
+                                 (((? derivation? source))
+                                  (derivation->output-path source))
+                                 ((source)
+                                  source)
+                                 (source
+                                  source))
+                     #:tests? ,tests?
+                     #:system ,system
+                     #:phases ,phases
+                     #:outputs %outputs
+                     #:build-flags ,build-flags
+                     #:search-paths ',(map search-path-specification->sexp
+                                           search-paths)
+                     #:inputs %build-inputs)))
+
+  (define guile-for-build
+    (match guile
+      ((? package?)
+       (package-derivation store guile system #:graft? #f))
+      (#f                                         ; the default
+       (let* ((distro (resolve-interface '(gnu packages commencement)))
+              (guile  (module-ref distro 'guile-final)))
+         (package-derivation store guile system #:graft? #f)))))
+
+  (build-expression->derivation store name builder
+                                #:inputs inputs
+                                #:system system
+                                #:modules imported-modules
+                                #:outputs outputs
+                                #:guile-for-build guile-for-build))
+
+(define gerbil-build-system
+  (build-system
+    (name 'gerbil)
+    (description "The standard Gerbil build system")
+    (lower lower)))
diff --git a/guix/build/gerbil-build-system.scm b/guix/build/gerbil-build-system.scm
new file mode 100644
index 0000000000..4355d8e444
--- /dev/null
+++ b/guix/build/gerbil-build-system.scm
@@ -0,0 +1,78 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2021 Xinglu Chen <public@yoctocell.xyz>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build gerbil-build-system)
+  #:use-module ((guix build gnu-build-system) #:prefix gnu:)
+  #:use-module (guix build union)
+  #:use-module (guix build utils)
+  #:use-module (srfi srfi-26)
+  #:export (%standard-phases
+            gerbil-build))
+
+;;; Commentary:
+;;;
+;;; Build-side code for building Gerbil packages.
+;;;
+;;; Something to note is that there is no standard way to run tests
+;;; for Gerbil packages, so there is not `check' phase by default.
+;;;
+;;; Code:
+
+(define (gerbil-package? name)
+  "Whether NAME is a Gerbil package."
+  (string-prefix? "gerbil-" name))
+
+(define (gerbil-load-path inputs)
+  "Given an alist of inputs, INPUTS, return a list of directories to add
+to the GERBIL_LOADPTH environment variable."
+  (let* ((labels (map car inputs))
+         (gerbil-packages (filter gerbil-package? labels)))
+    (map (cut string-append <> "/lib/gerbil")
+         gerbil-packages)))
+  
+(define* (setup-gerbil-environment #:key inputs #:allow-other-keys)
+  ;; This is where the compiled modules will end up.
+  (setenv "GERBIL_PATH" (string-append (getcwd) "/.build"))
+  ;; Where to look for other Gerbil modules.
+  (setenv "GERBIL_LOADPATH" (string-join (gerbil-load-path inputs) ":")))
+  
+(define* (build #:key build-flags #:allow-other-keys)
+  ;; The build.ss script contians the build instructions.
+  (apply invoke "./build.ss" build-flags))
+
+(define* (install #:key outputs #:allow-other-keys)
+  (let ((out (assoc-ref outputs "out")))
+    (mkdir-p (string-append out "/lib/gerbil"))
+    (copy-recursively ".build/lib" (string-append out "/lib/gerbil"))
+    (copy-recursively ".build/bin" (string-append out "/bin"))))
+
+(define %standard-phases
+  (modify-phases gnu:%standard-phases
+    (delete 'bootstrap)
+    (delete 'configure)
+    (add-after 'unpack 'setup-gerbil-environment setup-gerbil-environment)
+    (replace 'build build)
+    (delete 'check)
+    (replace 'install install)))
+
+(define* (gerbil-build #:key (phases %standard-phases)
+                       #:allow-other-keys #:rest args)
+  "Build the given Gerbil packages, applying all of PHASES in order."
+  (apply gnu:gnu-build #:phases phases args))
+
+    